//+------------------------------------------------------------------+
//|                                                       Window.mq5 |
//|                                                             UBAS |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+

#include <Trade\SymbolInfo.mqh> 


#property copyright "UBAS"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1
//--- plot Label1
#property indicator_label1  "Label1"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrRed
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- indicator buffers
double         Label1Buffer[];
int               AMA_handle;                                     //    
double            AMA_buf[];  
string            my_symbol;                                       //   
ENUM_TIMEFRAMES   my_timeframe;
CSymbolInfo       m_SymbolInfo;   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,Label1Buffer,INDICATOR_DATA);
   my_symbol=Symbol();                                             //           
   my_timeframe=PERIOD_CURRENT;                                    //           
   m_SymbolInfo.Name(my_symbol);
   AMA_handle=iCustom(NULL,0,"Examples\\AMA");
   ChartIndicatorAdd(ChartID(),0,AMA_handle);
   ArraySetAsSeries(AMA_buf,true);  
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---
double a[2];
int BC =BarsCalculated(AMA_handle);
if(BC<rates_total)return(0);
for(int i=prev_calculated; i<BC;i++)
{
CopyBuffer(AMA_handle,0,BC-1-i,2,a);
Label1Buffer[i]=(a[1]-a[0])/m_SymbolInfo.Point();
}   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   IndicatorRelease(AMA_handle);                                   //       
   ArrayFree(AMA_buf);                                             //   iMA_buf                                          //   Close_buf  
  }